## route-rnd 0.9.2

=== Makefile ===
all:
	cd src/route-rnd && $(MAKE) all

clean:
	cd src/route-rnd && $(MAKE) clean
	-cd src_3rd/genht && $(MAKE) clean
	-cd src_3rd/genlist && $(MAKE) clean
	-cd src_3rd/genprique && $(MAKE) clean
	-cd src_3rd/genvector && $(MAKE) clean
	-cd src_3rd/libcdtr && $(MAKE) clean
	-cd src_3rd/libgrbs && $(MAKE) clean
	-cd src_3rd/libpsrand && $(MAKE) clean
	-cd src_3rd/libualloc && $(MAKE) clean
	-cd src_3rd/libusearch && $(MAKE) clean
	-cd src_3rd/libusteiner && $(MAKE) clean

distclean:
	cd src/route-rnd && $(MAKE) distclean
	-cd src_3rd/genht && $(MAKE) distclean
	-cd src_3rd/genlist && $(MAKE) distclean
	-cd src_3rd/genprique && $(MAKE) distclean
	-cd src_3rd/genvector && $(MAKE) distclean
	-cd src_3rd/libcdtr && $(MAKE) distclean
	-cd src_3rd/libgrbs && $(MAKE) distclean
	-cd src_3rd/libpsrand && $(MAKE) distclean
	-cd src_3rd/libualloc && $(MAKE) distclean
	-cd src_3rd/libusearch && $(MAKE) distclean
	-cd src_3rd/libusteiner && $(MAKE) distclean

install:
	cd src/route-rnd && $(MAKE) install
	cd doc && $(MAKE) install

linstall:
	cd src/route-rnd && $(MAKE) linstall
	cd doc && $(MAKE) linstall

uninstall:
	cd src/route-rnd && $(MAKE) uninstall
	cd doc && $(MAKE) uninstall

=== doc/Makefile ===
ROOT=..

include $(ROOT)/Makefile.conf

DOCDIR=$(install_root)$(DESTDIR)$(PREFIX)/share/doc/route-rnd

all: *.html
	@echo -n "HTMLS=" > Makefile.list
	@ls *.html | grep -v Autostyle.html | tr "\n" " " >> Makefile.list
	@echo  "" >> Makefile.list
	ROOT="" ./Autostyle.sh *.html

include ../Makefile.conf
include Makefile.list

install:
	mkdir -p $(DOCDIR)
	$(CP) $(HTMLS) $(DOCDIR)

linstall:
	mkdir -p $(DOCDIR)
	for n in $(HTMLS); do $(LN) $(PWD)/$$n $(DOCDIR)/$$n; done

uninstall:
	$(RM) $(DOCDIR)/*.html

=== doc/TRBS/Makefile ===
DPI=300
PICS = 2net.png 3net.png passthru1.png passthru2.png passthru3.png tri.png uturn.png path.png astar.png

all: $(PICS)

%.png: %.lht
	pcb-rnd -x png --dpi $(DPI) --as-shown --cam $@=doc $^

=== doc/detour/Makefile ===
# pcb-rnd/trunk/util/build_ps.sh
BUILD=./build_ps.sh

all:
	cd img && make
	make detour.pdf

detour.pdf: detour.ps
	ps2pdf detour.ps > detour.pdf

detour.ps:
	echo [0-9]*.html > ps.lst
	HTML2PS_OPTS="-f pdf.css --toc h" HTML2PS_SED="s/<h1>.*//;" $(BUILD) `cat ps.lst` > detour.ps


clean:
	rm HTML2PS.html ps.lst detour.ps

=== src/route-rnd/Makefile ===
ROOT=../..

include $(ROOT)/Makefile.conf
include Makefile.conf

CDT_COORD=-DCDT_COORD_T=double -Dcdt_precision=1000000.0
CFLAGS_TEMP_GRBS = -I..
CFLAGS = $(CFLAGS_RTRND) $(CDT_COORD) $(CFLAGS_TEMP_GRBS)
LOCLIBS = $(LOCLIBS_RTRND)
LDLIBS = -lm
LDFLAGS = $(LDFLAGS_RTRND)
OBJS = route-rnd.o rtree.o compat_misc.o data.o io.o util_grid.o htdi.o \
       util_rat.o netseg.o find.o rtpoly.o route_res.o conf.o
BINDIR=$(install_root)$(DESTDIR)$(PREFIX)/bin

all: libroute-rnd.a route-rnd$(EXE)

include ../plugins/Makefile.inc
include Makefile.dep

route-rnd$(EXE): main.o $(OBJS)  $(BUILDIN_O) $(LOCLIBS)
	$(CC) -o $@ $(LDFLAGS) main.o $(OBJS) $(BUILDIN_O) $(LOCLIBS) $(LDLIBS)

libroute-rnd.a: main.o $(OBJS)  $(BUILDIN_O) $(LOCLIBS)
	ar ru $@ main.o $(OBJS) $(BUILDIN_O) $(LOCLIBS)

$(ROOT)/src_3rd/genvector/libgenvector.a:
	cd $(ROOT)/src_3rd/genvector && make libgenvector.a

$(ROOT)/src_3rd/genht/libgenht.a:
	cd $(ROOT)/src_3rd/genht && make libgenht.a

$(ROOT)/src_3rd/libusteiner/libusteiner.a: $(ROOT)/src_3rd/libusteiner/libusteiner.o $(ROOT)/src_3rd/libusteiner/libusteiner.h
	cd $(ROOT)/src_3rd/libusteiner && make libusteiner.a

$(ROOT)/src_3rd/libcdtr/libcdtr.a:
	cd $(ROOT)/src_3rd/libcdtr && make libcdtr.a CFLAGS_LIBCDTR="$(CDT_COORD)"

$(ROOT)/src_3rd/libualloc/libualloc.a:
	cd $(ROOT)/src_3rd/libualloc && make libualloc.a

$(ROOT)/src_3rd/libusearch/libusearch.a:
	cd $(ROOT)/src_3rd/libusearch && make libusearch.a

$(ROOT)/src_3rd/genprique/genprique.a:
	cd $(ROOT)/src_3rd/genprique && make genprique.a

dep:
	echo $(OBJS) $(BUILDIN_O) | ../../util/dep.sh $(CFLAGS) > Makefile.dep

install:
	mkdir -p $(BINDIR)
	$(CP) route-rnd$(EXE) $(BINDIR)/route-rnd$(EXE)

linstall:
	mkdir -p $(BINDIR)
	$(LN) $(PWD)/route-rnd$(EXE) $(BINDIR)/route-rnd$(EXE)

uninstall:
	$(RM) $(BINDIR)/route-rnd$(EXE)

clean:
	$(RM) $(OBJS) $(BUILDIN_O) route-rnd

distclean: clean

=== src_3rd/genht/Makefile ===
# use -DGENHT_WANT_INLINE to turn half of the API into static inline functions
PREFIX=/usr
INCDIR=$(install_root)$(DESTDIR)$(PREFIX)/include/genht
LIBDIR=$(install_root)$(DESTDIR)$(PREFIX)/lib

HOSTCC = $(CC)

VER_MAJOR=1
VER_MINOR=1
VER_PATCH=2
VER=$(VER_MAJOR).$(VER_MINOR).$(VER_PATCH)

CFLAGS=-g $(GENHT_CFLAGS)
LDFLAGS=$(GENHT_LDFLAGS)

BIN=mainsi
OBJS=htss.o htsp.o htsi.o htip.o htpp.o htpi.o hash.o siphash24.o
LIBSO=libgenht.so.$(VER)
LIBSO1=libgenht.so.$(VER_MAJOR)
LIBA=libgenht.a

all: version.h $(BIN) $(OBJS) $(LIBA) $(LIBSO)

clean:
	-rm $(BIN) $(OBJS) $(LIBA) $(LIBSO) genht_std.so genht_std.a version.h ver_edit

.SUFFIXES:
.SUFFIXES: .o .c

.c.o:
	$(CC) -o $@ -c -fPIC $< $(CFLAGS)

mainsi: mainsi.o htsi.o
	$(CC) -o $@ mainsi.o htsi.o $(LDFLAGS)

$(LIBSO): $(OBJS)
	$(CC) $(LDFLAGS) -shared -dynamic -rdynamic -o $@ $(OBJS)

$(LIBA): $(OBJS)
	ar rvu $@ $(OBJS)
	-ar s $@
	-ranlib $@

# for compatibility
genht_std.so: $(LIBSO)
	ln -s $(LIBSO) genht_std.so

# for compatibility
genht_std.a: $(LIBA)
	ln -s $(LIBA) genht_std.a

version.h: version.h.in ver_edit
	./ver_edit $(VER_MAJOR) $(VER_MINOR) $(VER_PATCH) < version.h.in > version.h

ver_edit: ver_edit.c
	$(HOSTCC) -o $@ $(CFLAGS) ver_edit.c

install_:
	mkdir -p $(INCDIR) $(LIBDIR)
	$(CP) `pwd`/hash.h $(INCDIR)/hash.h
	$(CP) `pwd`/siphash24.h $(INCDIR)/siphash24.h
	$(CP) `pwd`/ht.h $(INCDIR)/ht.h
	$(CP) `pwd`/ht.c $(INCDIR)/ht.c
	$(CP) `pwd`/version.h $(INCDIR)/version.h
	$(CP) `pwd`/ht_inlines.h $(INCDIR)/ht_inlines.h
	$(CP) `pwd`/ht_utils.h $(INCDIR)/ht_utils.h
	$(CP) `pwd`/htip.h $(INCDIR)/htip.h
	$(CP) `pwd`/htpi.h $(INCDIR)/htpi.h
	$(CP) `pwd`/htsi.h $(INCDIR)/htsi.h
	$(CP) `pwd`/htsp.h $(INCDIR)/htsp.h
	$(CP) `pwd`/htss.h $(INCDIR)/htss.h
	$(CP) `pwd`/htpp.h $(INCDIR)/htpp.h
	$(CP) `pwd`/$(LIBSO) $(LIBDIR)/$(LIBSO)
	$(CP) `pwd`/$(LIBA) $(LIBDIR)/$(LIBA)

uninstall:
	rm -rf $(INCDIR)
	rm $(LIBDIR)/$(LIBSO) $(LIBDIR)/$(LIBA) $(LIBDIR)/$(LIBSO1)

install:
	make install_ CP="cp"
	-@rm $(LIBDIR)/$(LIBSO1) 2>/dev/null
	ln -s $(LIBSO) $(LIBDIR)/$(LIBSO1)

linstall:
	make install_ CP="ln -s"
	-@rm $(LIBDIR)/$(LIBSO1) 2>/dev/null
	ln -s $(LIBSO) $(LIBDIR)/$(LIBSO1)

test: mainsi
	@./mainsi > mainsi.out
	@diff mainsi.ref mainsi.out
	@echo "*** QC pass ***"

=== src_3rd/genvector/Makefile ===
#CFLAGS = -I.. -O3 -Wall -ansi -pedantic
CFLAGS = -I.. -g $(GENVECTOR_CFLAGS)
LDFLAGS = $(GENVECTOR_LDFLAGS)
OBJS = gds_char.o vti0.o vts0.o vtp0.o vtii.o vti0.o vtd0.o
IMPL = genvector_impl.c genvector_impl.h genvector_undef.h

LIBA = libgenvector.a

all: $(LIBA)

$(LIBA): $(OBJS)
	ar ur $(LIBA) $(OBJS)
	-ar s $(LIBA)
	-ranlib $(LIBA)

gds_char.o: gds_char.c gds_char.h $(IMPL)
	$(CC) -c $(CFLAGS) $*.c -o $@

gds_wchar.o: gds_wchar.c gds_wchar.h $(IMPL)
	$(CC) -c $(CFLAGS) $*.c -o $@

vti0.o: vti0.c vti0.h $(IMPL)
	$(CC) -c $(CFLAGS) $*.c -o $@

vtd0.o: vtd0.c vtd0.h $(IMPL)
	$(CC) -c $(CFLAGS) $*.c -o $@

vts0.o: vts0.c vts0.h $(IMPL)
	$(CC) -c $(CFLAGS) $*.c -o $@

vtp0.o: vtp0.c vtp0.h $(IMPL)
	$(CC) -c $(CFLAGS) $*.c -o $@

vtii.o: vtii.c vtii.h $(IMPL)
	$(CC) -c $(CFLAGS) $*.c -o $@

clean:
	rm $(OBJS) $(LIBA) 2>/dev/null ; true

include ../Makefile.conf

install_:
	mkdir -p "$(INCDIR)" "$(LIBDIR)"
	$(CP) "$(PWD)/gds_char.h" "$(INCDIR)/gds_char.h"
	$(CP) "$(PWD)/gds_wchar.h" "$(INCDIR)/gds_wchar.h"
	$(CP) "$(PWD)/genvector_impl.h" "$(INCDIR)/genvector_impl.h"
	$(CP) "$(PWD)/genvector_undef.h" "$(INCDIR)/genvector_undef.h"
	$(CP) "$(PWD)/vti0.h" "$(INCDIR)/vti0.h"
	$(CP) "$(PWD)/vtii.h" "$(INCDIR)/vtii.h"
	$(CP) "$(PWD)/$(LIBA)" "$(LIBDIR)/$(LIBA)"

uninstall:
	rm $(LIBDIR)/$(LIBA)
	rm $(INCDIR)/gds_*.h $(INCDIR)/genvector*.h $(INCDIR)/vt*.h

install:
	make install_ CP="cp" PWD=`pwd`

linstall:
	make install_ CP="ln -s" PWD=`pwd`

=== src_3rd/libcdtr/Makefile ===
#CFLAGS_DBG=-Wall -O0 -g3 
#CFLAGS_COORDT=-DCDT_COORD_T=double -Dcdt_precision=1000000.0
CFLAGS=$(CFLAGS_DBG) $(CFLAGS_COORDT) $(CFLAGS_LIBCDTR) -I. -I.. -I../..
LDFLAGS=-lm $(LDFLAGS_LIBCDTR)

OBJS= cdt.o point.o edge.o triangle.o debug.o
LIBA=libcdtr.a

cdt_test: cdt_test.o $(OBJS)

include Makefile.dep

$(LIBA): $(OBJS)
	@touch $(LIBA)
	@rm $(LIBA)
	@ar ru $(LIBA) $(OBJS)
	-ar s $(LIBA)
	-ranlib $(LIBA)

cdt_test.o: cdt_test.c
	$(CC) $(CFLAGS) -c cdt_test.c -o $@

cdt.o: cdt.c
	$(CC) $(CFLAGS) -c cdt.c -o $@

point.o: point.c
	$(CC) $(CFLAGS) -c point.c -o $@

edge.o: edge.c
	$(CC) $(CFLAGS) -c edge.c -o $@

triangle.o: triangle.c
	$(CC) $(CFLAGS) -c triangle.c -o $@

test:
	cd regression && ./Test.sh

dep:
	echo $(OBJS) | ./dep.sh $(CFLAGS) > Makefile.dep

clean:
	-touch $(LIBA) $(OBJS) cdt_test.o cdt_test
	-rm $(LIBA) $(OBJS) cdt_test.o cdt_test

=== src_3rd/libgrbs/Makefile ===
ROOT=../..
SRC_3RD=$(ROOT)/src_3rd
CFLAGS = -Wall -g -I$(SRC_3RD) -I..
LIBS = $(SRC_3RD)/libualloc/libualloc.a $(SRC_3RD)/genht/libgenht.a $(SRC_3RD)/genvector/vtp0.o
LDFLAGS = -lm
OBJS=tester.o grbs.o debug.o addr_hash.o rtree.o

# These are #included in grbs.o for best link time optimization
GRBS_C=\
  route_common.c route_next.c route_realize.c route_remove.c route_postproc.c \
  route_detach.c obj_line.c obj_arc.c obj_point.c collision.c addr.c geo.c \
  force_attach.c force_attach.h

tester: $(OBJS)
	$(CC) -o tester $(OBJS) $(LIBS) $(LDFLAGS)

tester.o: tester.c grbs.h debug.h route.h

grbs.o: grbs.c $(GRBS_C)  grbs.h route.h debug.h addr_hash.h

debug.o: debug.c debug.h grbs.h

addr_hash.o: addr_hash.c addr_hash.h grbs.h

clean:
	-rm $(OBJS) tester

test:
	cd regression && ./Test.sh
	@echo "*** QC pass ***"

=== src_3rd/libusteiner/Makefile ===
# where to install:
PREFIX=/usr/local
INCDIR=$(DESTDIR)$(inst_root)$(PREFIX)/include/libusteiner
LIBDIR=$(DESTDIR)$(inst_root)$(PREFIX)/lib

SRC_3RD=../src_3rd
#CFLAGS_CFG = -Wall -g
CFLAGS = $(CFLAGS_CFG) -I$(SRC_3RD) -I.. $(CFLAGS_LIBUSTEINER)
LDFLAGS = -lm $(LDFLAGS_LIBUSTEINER)

LIBA = libusteiner.a
OBJSA = debug.o libusteiner.o
OBJS = tester.o $(OBJSA) $(SRC_3RD)/genvector/vtp0.o

all: tester $(LIBA)

$(LIBA): $(OBJSA)
	-rm $(LIBA)
	ar ru $(LIBA) $(OBJSA)

tester: $(OBJS)
	$(CC) -o tester $(OBJS) $(LDFLAGS)

tester.o: tester.c debug.h libusteiner.h
	$(CC) -c -o tester.o $(CFLAGS) tester.c

debug.o: debug.c debug.h libusteiner.h
	$(CC) -c -o debug.o $(CFLAGS) debug.c

libusteiner.o: libusteiner.c libusteiner.h
	$(CC) -c -o libusteiner.o $(CFLAGS) libusteiner.c

install_: $(LIBA)
	mkdir -p $(LIBDIR) $(INCDIR)
	$(CP) $(PWD)/libusteiner.h          $(INCDIR)/libusteiner.h
	$(CP) $(PWD)/debug.h                $(INCDIR)/debug.h
	$(CP) $(PWD)/$(LIBA)                $(LIBDIR)/$(LIBA)

uninstall:
	-rm $(INCDIR)/libusteiner.h $(INCDIR)/debug.h $(LIBDIR)/$(LIBA)
	-rmdir $(INCDIR)

install:
	make install_ CP="cp"

linstall:
	make install_ CP="ln -s"

clean:
	-rm $(LIBA) $(OBJS) tester

=== doc/GRBS/src/Makefile ===
all: ../geo.svg ../conc_pp_oa.svg ../conc_pp_ea.svg

../%.svg: %.lht
	pcb-rnd -x svg --cam $@=doc $^

=== src/plugins/rt_hace/Makefile ===
all_:
	make all

%:
	cd ../../route-rnd && make $@

=== debian/changelog ===
route-rnd (0.9.2-1) unstable; urgency=medium

  * first packaging

 -- Bdale Garbee <bdale@gag.com>  Sun, 10 Oct 2021 00:11:48 -0600

=== debian/control ===
Source: route-rnd
Section: electronics
Priority: optional
Maintainer: Debian Electronics Team <pkg-electronics-devel@lists.alioth.debian.org>
Uploaders: Bdale Garbee <bdale@gag.com>
Build-Depends: debhelper (>= 13)
Standards-Version: 4.6.0
Homepage: http://repo.hu/projects/route-rnd
Vcs-Git: https://salsa.debian.org/electronics-team/route-rnd.git
Vcs-Browser: https://salsa.debian.org/electronics-team/route-rnd

Package: route-rnd
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: external autorouter for pcb-rnd
 route-rnd is a generic 'external autorouter' developed for the ringdove 
 suite.  It speaks the tEDAx format (http://www.repo.hu/projects/tedax). A 
 route request tEDAx document is generated by a PCB editor, then route-rnd is 
 called and writes the route result tEDAx which then can be fed back to the 
 PCB editor to create the tracks. This process is demonstrated by ringdove's
 pcb-rnd external autorouter feature.
 .
 Route-rnd is a modular router that offers different routing algorithms.

=== debian/rules ===
#!/usr/bin/make -f

DH_VERBOSE = 1
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

%:
ifeq (mipsel,$(findstring mipsel,$(DEB_HOST_ARCH)))
	dh $@ --no-parallel
else ifeq (mips64el,$(findstring mips64el,$(DEB_HOST_ARCH)))
	dh $@ --no-parallel
else
	dh $@
endif

override_dh_auto_clean:
	# only try to run dh_auto_clean if configure has been run
	test -f Makefile.conf && dh_auto_clean || true

override_dh_auto_configure:
	./configure \
		--LDFLAGS='$(LDFLAGS)' \
		--CFLAGS='$(CFLAGS) $(CPPFLAGS)' \
		--prefix=/usr 

override_dh_install:

=== debian/watch ===
version=3
opts=dversionmangle=s/\+repack.*$// \
  http://www.repo.hu/projects/route-rnd/releases/route-rnd-(.*)\.tar\.gz

## route-rnd 0.9.3

=== Makefile ===
--- 
+++ 
@@ -14,7 +14,7 @@
 	-cd src_3rd/libusearch && $(MAKE) clean
 	-cd src_3rd/libusteiner && $(MAKE) clean
 
-distclean:
+distclean: clean
 	cd src/route-rnd && $(MAKE) distclean
 	-cd src_3rd/genht && $(MAKE) distclean
 	-cd src_3rd/genlist && $(MAKE) distclean

=== doc/Makefile ===
ROOT=..

include $(ROOT)/Makefile.conf

all: *.html
	@echo -n "HTMLS=" > Makefile.list
	@ls *.html | grep -v Autostyle.html | tr "\n" " " >> Makefile.list
	@echo  "" >> Makefile.list
	ROOT="" ./Autostyle.sh *.html

include ../Makefile.conf
include Makefile.list

install:
	$(MKDIR) $(DOCDIR)
	$(CP) $(HTMLS) $(DOCDIR)
	cd man && $(MAKE) install

linstall:
	$(MKDIR) $(DOCDIR)
	for n in $(HTMLS); do $(LN) $(PWD)/$$n $(DOCDIR)/$$n; done
	cd man && $(MAKE) linstall

uninstall:
	$(RM) $(DOCDIR)/*.html
	cd man && $(MAKE) uninstall

=== doc/man/Makefile ===
# This Makefile is a plain old hand written one; all configuration settings
# are included from $(ROOT)/Makefile.conf which is scconfig generated
ROOT=../..

IN=route-rnd.1.mml
OUT_HTML = route-rnd.1.html
OUT_MAN1 = route-rnd.1
OUT_LINT = route-rnd.1.lint

OUTPUT = $(OUT_HTML) $(OUT_MAN1) index.html
MML = /usr/bin/mml

all: $(OUTPUT)

lint: $(OUT_LINT)

.SUFFIXES: .html .mml .lint

.mml.html: .mml_linkmap
	$(MML) -i copyright.mml -f html $<  > $@

.mml:
	$(MML) -i copyright.mml -f man $<  > $@

.mml_linkmap:
	$(MML) -i copyright.mml -f linkmap $(IN) > $@

index.html: $(IN)
	@echo '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">' > $@
	@echo '<HTML><HEAD><meta http-equiv="Content-Type" content="text/html;charset=us-ascii"><TITLE>man page index - route-rnd</TITLE></HEAD><BODY><UL>' >> $@
	$(MML) -i copyright.mml -f indexhtml $(IN) >> $@
	@echo "</UL></BODY></HTML>" >> $@

clean:

distclean:

genclean:
	rm $(OUTPUT) 2>/dev/null ; true

.mml.lint:
	$(MML) -i copyright.mml -f lint $<

install_all:
	$(MKDIR) "$(MAN1DIR)"
	$(HOW) "route-rnd.1" "$(MAN1DIR)/route-rnd.1"

uninstall_all:
	$(HOW) "$(MAN1DIR)/route-rnd.1"

install:
	$(MAKE) install_all HOW="$(CP)"

linstall:
	$(MAKE) install_all HOW="$(LN)"

uninstall:
	$(RM) "$(MAN1DIR)/route-rnd.1"

include $(ROOT)/Makefile.conf

=== src/route-rnd/Makefile ===
--- 
+++ 
@@ -49,17 +49,17 @@
 	echo $(OBJS) $(BUILDIN_O) | ../../util/dep.sh $(CFLAGS) > Makefile.dep
 
 install:
-	mkdir -p $(BINDIR)
+	$(MKDIR) $(BINDIR)
 	$(CP) route-rnd$(EXE) $(BINDIR)/route-rnd$(EXE)
 
 linstall:
-	mkdir -p $(BINDIR)
+	$(MKDIR) $(BINDIR)
 	$(LN) $(PWD)/route-rnd$(EXE) $(BINDIR)/route-rnd$(EXE)
 
 uninstall:
 	$(RM) $(BINDIR)/route-rnd$(EXE)
 
 clean:
-	$(RM) $(OBJS) $(BUILDIN_O) route-rnd
+	$(RM) $(OBJS) $(BUILDIN_O) route-rnd main.o libroute-rnd.a
 
 distclean: clean

=== src_3rd/genlist/Makefile ===
PREFIX=/usr
INCDIR=$(install_root)$(DESTDIR)$(PREFIX)/include/genlist
LIBDIR=$(install_root)$(DESTDIR)$(PREFIX)/lib

CFLAGS = -I. -I.. $(GENLIST_CFLAGS)
LDFLAGS = $(GENLIST_LDFLAGS)

#CFLAGS += -Wall -g -I. -I..

OBJS = genlistalloc.o genadlist.o
LIBA = libgenlist.a

all: $(LIBA) genlist.a

$(LIBA): $(OBJS)
	ar r $(LIBA) $(OBJS)
	-ar s $(LIBA)
	-ranlib $(LIBA)

# obsolete: DO NOT DEPEND ON THIS
genlist.a: $(LIBA)
	cp $(LIBA) genlist.a

example_ad: example_ad.o $(OBJS)

example_d: example_d.c gendlist.h

clean:
	rm $(OBJS) $(LIBA) genlist.a example_ad example_d; true

install_:
	mkdir -p $(INCDIR) $(LIBDIR)
	$(CP) `pwd`/genadlist.h        $(INCDIR)/genadlist.h
	$(CP) `pwd`/gendlist.h         $(INCDIR)/gendlist.h
	$(CP) `pwd`/genlistalloc.h     $(INCDIR)/genlistalloc.h
	$(CP) `pwd`/gentdlist_impl.h   $(INCDIR)/gentdlist_impl.h
	$(CP) `pwd`/gentdlist_impl.c   $(INCDIR)/gentdlist_impl.c
	$(CP) `pwd`/gentdlist_undef.h  $(INCDIR)/gentdlist_undef.h
	$(CP) `pwd`/$(LIBA)            $(LIBDIR)/$(LIBA)

uninstall:
	rm $(INCDIR)/$(INCDIR)/genadlist.h
	rm $(INCDIR)/$(INCDIR)/gendlist.h
	rm $(INCDIR)/$(INCDIR)/genlistalloc.h
	rm $(INCDIR)/$(INCDIR)/gentdlist_impl.h
	rm $(INCDIR)/$(INCDIR)/gentdlist_undef.h
	rm $(LIBDIR)/$(LIBA)

install:
	make install_ CP="cp"

linstall:
	make install_ CP="ln -s"

=== src_3rd/genvector/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #CFLAGS = -I.. -O3 -Wall -ansi -pedantic
 CFLAGS = -I.. -g $(GENVECTOR_CFLAGS)
 LDFLAGS = $(GENVECTOR_LDFLAGS)
-OBJS = gds_char.o vti0.o vts0.o vtp0.o vtii.o vti0.o vtd0.o
+OBJS = gds_char.o vti0.o vts0.o vtp0.o vtii.o vti0.o vtd0.o vtl0.o
 IMPL = genvector_impl.c genvector_impl.h genvector_undef.h
 
 LIBA = libgenvector.a
@@ -46,6 +46,7 @@
 	$(CP) "$(PWD)/genvector_impl.h" "$(INCDIR)/genvector_impl.h"
 	$(CP) "$(PWD)/genvector_undef.h" "$(INCDIR)/genvector_undef.h"
 	$(CP) "$(PWD)/vti0.h" "$(INCDIR)/vti0.h"
+	$(CP) "$(PWD)/vtl0.h" "$(INCDIR)/vtl0.h"
 	$(CP) "$(PWD)/vtii.h" "$(INCDIR)/vtii.h"
 	$(CP) "$(PWD)/$(LIBA)" "$(LIBDIR)/$(LIBA)"

=== src_3rd/libcdtr/Makefile ===
--- 
+++ 
@@ -1,6 +1,9 @@
 #CFLAGS_DBG=-Wall -O0 -g3 
 #CFLAGS_COORDT=-DCDT_COORD_T=double -Dcdt_precision=1000000.0
-CFLAGS=$(CFLAGS_DBG) $(CFLAGS_COORDT) $(CFLAGS_LIBCDTR) -I. -I.. -I../..
+
+LIBRND_PREFIX=/usr/local
+
+CFLAGS=$(CFLAGS_DBG) $(CFLAGS_COORDT) $(CFLAGS_LIBCDTR) -I. -I.. -I../.. -I$(LIBRND_PREFIX)/include/librnd4/librnd/src_3rd
 LDFLAGS=-lm $(LDFLAGS_LIBCDTR)
 
 OBJS= cdt.o point.o edge.o triangle.o debug.o

=== src_3rd/libgrbs/Makefile ===
--- 
+++ 
@@ -3,11 +3,11 @@
 CFLAGS = -Wall -g -I$(SRC_3RD) -I..
 LIBS = $(SRC_3RD)/libualloc/libualloc.a $(SRC_3RD)/genht/libgenht.a $(SRC_3RD)/genvector/vtp0.o
 LDFLAGS = -lm
-OBJS=tester.o grbs.o debug.o addr_hash.o rtree.o
+OBJS=tester.o grbs.o debug.o addr_hash.o rtree.o snapshot.o
 
 # These are #included in grbs.o for best link time optimization
 GRBS_C=\
-  route_common.c route_next.c route_realize.c route_remove.c route_postproc.c \
+  route_common.c route_next.c route_realize.c route_remove.c \
   route_detach.c obj_line.c obj_arc.c obj_point.c collision.c addr.c geo.c \
   force_attach.c force_attach.h

=== src_3rd/libpsrand/Makefile ===
MKDIR=mkdir -p
CP=cp
PREFIX=/usr/local
LIBDIR=$(install_root)$(DESTDIR)$(PREFIX)/lib
INCDIR=$(install_root)$(DESTDIR)$(PREFIX)/include/libpsrand
CFLAGS_DEBUG = -Wall -g -std=c89 --pedantic
CFLAGS = -I.. $(CFLAGS_DEBUG)

OBJS = minstd.o mtw.o xorshift.o


all: $(OBJS)

minstd.o: minstd.c minstd.h

mtw.o: mtw.c mtw.h

xorshift.o: xorshift.c xorshift.h

static: libpsrand.a

libpsrand.a: $(OBJS)
	-rm libpsrand.a
	ar r libpsrand.a $(OBJS)

shared: libpsrand.so

libpsrand.so: $(OBJS)
	$(CC) $(LDFLAGS) -shared -o libpsrand.so $(OBJS)

install:
	$(MKDIR) $(INCDIR) $(LIBDIR)
	$(CP) minstd.h mtw.h xorshift.h $(INCDIR)
	-$(CP) libpsrand.a $(LIBDIR)
	-$(CP) libpsrand.so $(LIBDIR)

uninstall:
	rm $(INCDIR)/minstd.h $(INCDIR)/mtw.h $(INCDIR)/xorshift.h
	-rmdir $(INCDIR)
	-rm $(LIBDIR)/libpsrand.a $(LIBDIR)/libpsrand.so

clean:
	rm $(OBJS) libpsrand.a libpsrand.so

=== doc/detour/img/Makefile ===
DPI=200
LHTS = \
	ex_3net.png \
	ex_bneck.png \
	ex_multi1.png \
	ex_order.png \
	ex_osc.png \
	ex_spiral.png \
	ex_topo.png \
	ex_zigzag.png \
	geo_go_around.png \
	geo_hcross.png \
	geo_hnear.png \
	geo_hpierce.png \
	geo_hwallin.png \
	geo_hwallin_brk.png \
	topo_cross1.png \
	topo_cross2.png

DOTS = \
	topo_tree2.png \
	topo_tree1.png \
	geo_cases.png

all: $(LHTS) $(DOTS)

%.png: %.lht
	pcb-rnd -x png --dpi $(DPI) --as-shown --cam $@=doc $^

%.png: %.dot
	dot -Tpng $^ > $@

=== debian/changelog ===
route-rnd (0.9.3-1) unstable; urgency=high

  * new upstream version

 -- Bdale Garbee <bdale@gag.com>  Thu, 12 Dec 2024 02:03:13 -0700

route-rnd (0.9.2-3) unstable; urgency=high

  * resolve FTBFS with GCC-14 by adjusting CFLAGS, closes: #1075451

 -- Bdale Garbee <bdale@gag.com>  Tue, 20 Aug 2024 12:30:06 -0600

route-rnd (0.9.2-2) unstable; urgency=medium

  * add Suggests for other Ringdove applications
  * move to Ringdove subgroup on salsa

 -- Bdale Garbee <bdale@gag.com>  Thu, 13 Jun 2024 17:06:57 -0400

=== debian/control ===
--- 
+++ 
@@ -4,14 +4,16 @@
 Maintainer: Debian Electronics Team <pkg-electronics-devel@lists.alioth.debian.org>
 Uploaders: Bdale Garbee <bdale@gag.com>
 Build-Depends: debhelper (>= 13)
+X-DH-Compat: 13
 Standards-Version: 4.6.0
 Homepage: http://repo.hu/projects/route-rnd
-Vcs-Git: https://salsa.debian.org/electronics-team/route-rnd.git
-Vcs-Browser: https://salsa.debian.org/electronics-team/route-rnd
+Vcs-Git: https://salsa.debian.org/electronics-team/ringdove-eda/route-rnd.git
+Vcs-Browser: https://salsa.debian.org/electronics-team/ringdove-eda/route-rnd
 
 Package: route-rnd
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
+Suggests: camv-rnd, pcb-rnd, sch-rnd
 Description: external autorouter for pcb-rnd
  route-rnd is a generic 'external autorouter' developed for the ringdove 
  suite.  It speaks the tEDAx format (http://www.repo.hu/projects/tedax). A

=== debian/rules ===
--- 
+++ 
@@ -4,6 +4,7 @@
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
 DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
+export DEB_CFLAGS_MAINT_APPEND = -Wno-error=incompatible-pointer-types
 
 %:
 ifeq (mipsel,$(findstring mipsel,$(DEB_HOST_ARCH)))
